"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class VariantRepresentation(ProtocolElement):
    """
    A variant represented in a given assembly
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "assembly",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_8_4 import opencb as opencb_2_9_3
        from protocols.protocol_8_4 import reports as reports_6_8_0

        return {
            "annotation": opencb_2_9_3.VariantAnnotation,
            "breakpoints": reports_6_8_0.BreakPoint,
            "rearrangement": reports_6_8_0.Rearrangement,
            "shortTandemRepeatReferenceData": reports_6_8_0.ShortTandemRepeatReferenceData,
            "smallVariantCoordinates": reports_6_8_0.VariantCoordinates,
            "structuralVariantCoordinates": reports_6_8_0.Coordinates,
        }

    @classmethod
    def getEmbeddedEnums(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_8_4 import opencb as opencb_2_9_3
        from protocols.protocol_8_4 import reports as reports_6_8_0

        return {
            "assembly": reports_6_8_0.Assembly,
            "smallVariantType": opencb_2_9_3.VariantType,
            "variantType": reports_6_8_0.StructuralVariantType,
        }

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_8_4 import cva as cva_1_5_3
        from protocols.protocol_8_4 import opencb as opencb_2_9_3
        from protocols.protocol_8_4 import reports as reports_6_8_0

        return {
            "org.opencb.biodata.models.variant.avro.VariantAnnotation": opencb_2_9_3.VariantAnnotation,
            "org.gel.models.report.avro.Assembly": reports_6_8_0.Assembly,
            "org.gel.models.report.avro.BreakPoint": reports_6_8_0.BreakPoint,
            "org.gel.models.report.avro.Rearrangement": reports_6_8_0.Rearrangement,
            "org.gel.models.report.avro.ShortTandemRepeatReferenceData": reports_6_8_0.ShortTandemRepeatReferenceData,
            "org.gel.models.report.avro.VariantCoordinates": reports_6_8_0.VariantCoordinates,
            "org.opencb.biodata.models.variant.avro.VariantType": opencb_2_9_3.VariantType,
            "org.gel.models.report.avro.Coordinates": reports_6_8_0.Coordinates,
            "org.gel.models.report.avro.StructuralVariantType": reports_6_8_0.StructuralVariantType,
            "org.gel.models.cva.avro.VariantRepresentation": cva_1_5_3.VariantRepresentation,
        }

    __slots__ = [
        "assembly",
        "annotation",
        "annotationsVersion",
        "annotatorVersion",
        "breakpoints",
        "leftInsSeq",
        "rearrangement",
        "rightInsSeq",
        "shortTandemRepeatReferenceData",
        "smallVariantCoordinates",
        "smallVariantType",
        "structuralVariantCoordinates",
        "variantType",
    ]

    def __init__(
        self,
        assembly,
        annotation=None,
        annotationsVersion=None,
        annotatorVersion=None,
        breakpoints=None,
        leftInsSeq=None,
        rearrangement=None,
        rightInsSeq=None,
        shortTandemRepeatReferenceData=None,
        smallVariantCoordinates=None,
        smallVariantType=None,
        structuralVariantCoordinates=None,
        variantType=None,
        validate=None,
        **kwargs
    ):
        """Initialise the cva_1_5_3.VariantRepresentation model.

        :param assembly:
            The assembly on which this variant is represented
        :type assembly: Assembly
        :param annotation:
            Variant annotation
        :type annotation: None | VariantAnnotation
        :param annotationsVersion:
            The annotator data version
        :type annotationsVersion: None | str
        :param annotatorVersion:
            The annotator software version
        :type annotatorVersion: None | str
        :param breakpoints:
            Chromosomal rearrangements breakpoints
        :type breakpoints: None | list[BreakPoint]
        :param leftInsSeq:
            Left insertion sequence
        :type leftInsSeq: None | str
        :param rearrangement:
            Chromosomal rearrangement
        :type rearrangement: None | list[Rearrangement]
        :param rightInsSeq:
            Right insertion sequence
        :type rightInsSeq: None | str
        :param shortTandemRepeatReferenceData:
            Short Tandem Repeat reference data
        :type shortTandemRepeatReferenceData: None | ShortTandemRepeatReferenceData
        :param smallVariantCoordinates:
            Small variant coordinates if this is a small variant
        :type smallVariantCoordinates: None | VariantCoordinates
        :param smallVariantType:
            Small Variant Type
        :type smallVariantType: None | VariantType
        :param structuralVariantCoordinates:
            Structural variant coordinates if this is a structural variant
        :type structuralVariantCoordinates: None | Coordinates
        :param variantType:
            Structural Variant Type as would appear in VCF
        :type variantType: None | StructuralVariantType
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "1.5.3"
